var cqr_browser = "";
var cqrOpenTarget = "";

// Content variables globals
var cqrPageSelection = "";
var cqrPageURL = "";
var cqrPageHost = "";
var cqrLinkURL = "";
var cqrImgName = "";
var cqrImgURL = "";
var cqrPageTitle = "";
var cqrClipboardText = "";
var cqrPageSource= "";
var cqrCurPageCharset = ""; 

// Hotmenu globals
var cqrUseCtrlForHM = false;
var cqrUseMiddleClickForHM = false;
var cqrMiddleClickMouseUp = false;
var cqrMiddleClickDelayms = 500;
var cqrMiddleClickHidems = 700;
var cqrHotMenuShown = false;
var cqrHotMenuDelayThreadsRunning = [];


var cqrAction = "";
var cqrActionPrompt = "";
var cqrConfigLastWillId = "";
var cqrConfigLastWillCtrl = false;
var cqrTabRef = "";
var cqrWndRef = "";
var cqrEntryId = "";    // this stores then entry id in case
                        // we need to do an extra round-trip
                        // waiting for the sidebar to finish loading


//Inits
conQueryInit();

function conQueryInit(){
    prfs_LoadMain();
    lastDirState = plg_GetDirState();
    srcDirChanged();
    plg_QuickLoadAll();

    if (cqrMailFlag){
        try {
            cqr_browser = getMessageBrowser();
        } catch (err) {
            //XXX for TB message compose pane. Later
            cqr_browser  = document.getElementById('content-frame');
        }
    }else{
        var navUA = navigator.userAgent.toString();
        if (navUA.search('SeaMonkey')<0){
            cqr_browser = document.getElementById("content");
            //cqr_browser = getBrowser();
        } else {
            cqrPopupFactorX = 0;
            cqrPopupFactorY = 0;
        }
    }
}

//Tools menu handler
function cqrHandleToolsMenu(event){
try{
    if (event.target.childNodes[0] && 
       (event.target.childNodes[0].id == "menu_ToolsPopup" || 
        event.target.childNodes[0].id == "taskPopup")){
        var cqr_cfg = window.document.getElementById('cq-cfg-menu');
        //This will require restarting, but perfomance is important :)
        //cqrHideFromTools = prfs_ReadItem("Main.HideFromTools");
        if (cqr_cfg) cqr_cfg.hidden = cqrHideFromTools;
  }
}catch(err){cqerr(err, "cqrHandleToolsMenu sub")}
}


document.addEventListener("contextmenu", cqrHandleContextMenu, true);
document.addEventListener("DOMMenuItemActive", cqrHandleToolsMenu, true);

document.addEventListener("mousedown", 
    function(event){
        cqrMiddleClickMouseUp = false;
        prfs_LoadMain();
        if (event.button==1 
            && cqrUseHotMenu 
            && cqrUseMiddleClickForHM
            && event.explicitOriginalTarget.nodeName != 'tabbrowser'
            ) {
            if (cqrHotMenuDelayThreadsRunning.length == 0) {
                cqrMiddleClickMouseUp = false;
            }
            cqrHotMenuDelayThreadsRunning.push('');
            document.popupNode = event.target;
            eventX = event.clientX;
            eventY = event.clientY; 
            getPageParams(event);

            // will open popup after delay if the middle mouse button wasn't released
            setTimeout(function() {
                if (!cqrMiddleClickMouseUp && cqrHotMenuDelayThreadsRunning.length < 2){
                    cqrHotMenuShown = true;
                    cqrShowHotmenu('yes', eventX, eventY);
                    
                    // and will close popup after after a while if button isn't released
                    //if (cqrMiddleClickHidems != 0) {
                        setTimeout(function() {
                            if (!cqrMiddleClickMouseUp) {
                                var hotmenu = window.document.getElementById("cq-hotmenu");
                                cqrHotMenuShown = false;
                                hotmenu.hidePopup();
                            }
                        }, cqrMiddleClickHidems)
                    //}
                }
            cqrHotMenuDelayThreadsRunning.pop();
            }, cqrMiddleClickDelayms)
        }
    }, true);

window.addEventListener("mouseup",
    function(event){
        if (cqrUseMiddleClickForHM && event.button==1){
            cqrMiddleClickMouseUp = true;
        }
    }, true);


window.addEventListener("click",
    function(event){
        if (event.button==1 &&
            cqrUseHotMenu &&
            cqrUseMiddleClickForHM){
            if (cqrHotMenuShown == true) {
                event.preventDefault();
                event.preventBubble();
                event.preventCapture();
                event.stopPropagation();
                cqrHotMenuShown = false;
                return false;
            }
            cqrMiddleClickMouseUp = true;
        }
    }, true);


function cqrHandleContextMenu(event){
try{
  getPageParams(event);
  
  var kShift = "";
  if (event.shiftKey || event.ctrlKey ){kShift = "yes"}
  
  prfs_LoadMain();
  if ((kShift) && (cqrUseHotMenu) && cqrUseCtrlForHM){
    eventX = event.clientX;
    eventY = event.clientY; 

    document.popupNode = event.target;
    event.preventDefault();
    cqrShowHotmenu(kShift, eventX, eventY);
  } else {
    FillMainMenu();
  }
}catch(err){cqerr(err, 'ContextMenu handler')}
}

/// HotMenu. Idea and early realizations made by Henrik Gulbrandsen.
function cqrShowHotmenu(kShift, x, y, trg){
try{
  var hotmenu = window.document.getElementById("cq-hotmenu");
  if (!hotmenu) {
    hotmenu = window.document.createElement("menupopup");
    hotmenu.id = "cq-hotmenu";
    window.document.documentElement.appendChild(hotmenu);
  }
  //hotmenu.position = 'at_pointer'; //at_pointer
  FillMenu(kShift, "");
  if(!cqr_browser) cqr_browser = getBrowser();
  hotmenu.showPopup(cqr_browser, x, y, "context","bottomleft","topleft");
}catch(er){cqerr(er, "cqrShowHotmenu sub")}
}

function FillMainMenu(){
try{
    var doc = document;
    var dataUpdated = false;
    if (cqrMailFlag) {
        var bContextMenu = doc.getElementById("messagePaneContext") || doc.getElementById("editorContentContext");
    } else {
        var bContextMenu = doc.getElementById("contentAreaContextMenu");
    }
    var cqmenu = doc.getElementById("cq-menu");
    cqmenu.hidden = cqrHideQueryTo;
    var entriesTrash = [];
    for (i=0; i < bContextMenu.childNodes.length; i++){
        if (bContextMenu.childNodes[i].getAttribute("conquery_flag")!=""){
            entriesTrash.push(bContextMenu.childNodes[i]);
        }
    }
    for (each in entriesTrash) bContextMenu.removeChild(entriesTrash[each]);
  
    if (cqrMainContextLimit > 0){
        bContextMenu.insertBefore(crtSeparator(doc), cqmenu);
        lastDirState = plg_GetDirState();
        if (srcDirChanged()) {
            updated = "true";
            plg_QuickLoadAll();
        } else {
            prfs_UpdateEntries();
        }
        //getPageParams();  
        dataUpdated = true;
        
        var entries = EntryHash.mainSet(cqrMainContextLimit);
        for (id in entries){
            evalContext(entries[id]);
            bContextMenu.insertBefore(crtMenuItem(doc, entries[id], "mainSet"), cqmenu);
        }
    }

    if (!cqrShowCSPInMainMenu) return;
  
    if (!dataUpdated){
        lastDirState = plg_GetDirState();
        if (srcDirChanged()) {
            updated = "true";
            plg_QuickLoadAll();
        }
        prfs_UpdateEntries();
    }

    entries = EntryHash.showifSet();
    for (entry in entries){
        if (evalContext(entries[entry])) {
            bContextMenu.insertBefore(crtMenuItem(doc, entries[entry], "showifSet"), cqmenu);
        }
    }
}catch(er){cqerr(er, "FillMainMenu sub")}
}

function FillMenu(kShift, allshowif){
try{
    var doc = window.document;
    var updated = false;
    var recommend = [];
    prfs_LoadMain();
    lastDirState = plg_GetDirState();
    if (srcDirChanged()){
        updated = "true";
        plg_QuickLoadAll();
    }
    prfs_UpdateEntries();
    
    if ((kShift) && (cqrUseHotMenu)) {
        var ppMenu = doc.getElementById("cq-hotmenu");
        var entries = EntryHash.conquerySet(0);
        var forceCSPShowInMain = true;
    } else {
        var ppMenu = doc.getElementById("cq-ppm");
        var entries = EntryHash.conquerySet(cqrMainContextLimit);
        var forceCSPShowInMain = false;
    }

    hasEntries = 0;
    while (ppMenu.hasChildNodes()) ppMenu.removeChild(ppMenu.lastChild);
    
    for (entry in entries) {
        hasEntries = 1;
        evalContext(entries[entry]);
        mItem = crtMenuItem(doc, entries[entry], "conquerySet");
        ppMenu.appendChild(mItem);
    }

    if (!cqrShowCSPInMainMenu || forceCSPShowInMain){
        entries = EntryHash.showifSet();
        for (entry in entries){
            if (evalContext(entries[entry])) {
                hasEntries = 1;
                ppMenu.appendChild(crtMenuItem(doc, entries[entry], "showifSet"))
            }
        }
    }
    
    if (hasEntries == 0) {
        var mItem = doc.createElement("menuitem");
        mItem.setAttribute("class", "menuitem-iconic");
        mItem.setAttribute("label", cqrMess.GetStringFromName('cqr.menu.NoPluginsFound'));
        //mItem.setAttribute("tooltiptext", cqrMess.GetStringFromName('cqr.menu.plgToolTip'));
        mItem.setAttribute("tooltiptext", cqrMess.GetStringFromName('cqr.menu.ClickToConfigure'));
        mItem.setAttribute("oncommand", "OpenCfgDialog();");
        mItem.setAttribute("conquery_flag", "conquerySet");
        ppMenu.appendChild(mItem);
    }
    lastDirState = null;
    ppMenu = null;
    ppItem = null;
    entries = null;
}catch(er){cqerr(er, "FillMenu")}
}

function crtSeparator(doc){
    retItem = doc.createElement("menuseparator");
    retItem.setAttribute("conquery_flag", "conquery");
    return retItem;
}

function crtMenuItem(doc, entry, flag){
  var retItem = doc.createElement("menuitem");
  retItem.setAttribute("class", "menuitem-iconic");
    if (!entry.iconpath){
      if (cqrHTTPIcon){
          icourl = url2host(entry.Action);
          if (icourl) {retItem.setAttribute("image", icourl + "/favicon.ico")};
      }
    }else{
      retItem.setAttribute("image", "file://" + entry.iconpath);
    }
  retItem.setAttribute("label", entry.Title);
  retItem.setAttribute("tooltiptext", cqrMess.GetStringFromName('cqr.menu.plgToolTip'));
  retItem.setAttribute("oncommand", "ProcessEntry(event.ctrlKey, '"+entry.eId+"')");
  retItem.setAttribute("conquery_flag", flag);
  return retItem;
}

function detecttrg(evnt){
 if (evnt.originalTarget.localName == "menuseparator") FillMenu(false,true);
}

function ProcessEntry(ctrl, EntryId){
    var entry = EntryHash._Item(EntryId);
    if (ctrl) cqrShowAlternatives = true;
    //if plugin not loaded - load it
    if (!entry.Inputs){
        entry = plg_ReadData(entry.filepath);
        entry.Context = EntryHash.Items[EntryId].Context;
        entry.lastmatch = EntryHash.Items[EntryId].lastmatch;
        EntryHash._AddEntryObj(entry, entry.eId);
    }
    PrepareAction(entry);
    if (cqrcancel){
        resetenv();
        return;
    }

    if (cqrMailFlag){
        //if working under Thaunderbird or Mozilla Mail, there is no way to POST data
        //so, will convert it to URL-encoded and open as external link. 
        //P.S. Well, actually, Mozilla Mail can do the POST, but sorry: it is 
        //too complex to work with MM and TB separately.
        try{
            if (entry.Action){
                var cqrurl = cqrAction;
            } else {
                var cqrurl = entry.Action;
            }
            firstpass = true;
            for (each in QueryHash){
                if (firstpass){
                    cqrurl = cqrurl + "?" + each + "=" + QueryHash[each];
                    firstpass = false;
                } else {
                    cqrurl = cqrurl + "&" + each + "=" + QueryHash[each];
                }
            }
            var mess = Components.classes["@mozilla.org/messenger;1"].getService(Components.interfaces.nsIMessenger);
            mess.launchExternalURL(encodeURI(cqrurl));
            resetenv();
            return;
        }catch(er){cqerr(er, "ProcessEntry sub (mail)")}
    }
    
    cqrOpenTarget = getOpenTarget(entry, EntryId);
    if(cqrOpenTarget) {
        window.setTimeout('formIt("'+ EntryId + '");', 70);
    }
}

function getOpenTarget(item, EntryId){
try{
    if(!cqr_browser) cqr_browser = getBrowser();
    //This returns window or tab object for query proccessing according to user settings
    //related to "open results in.." pref.
    
    //Hack for forced opening in targets, other than defined in general settings
    useTargetForOpen = item.forcein || cqrOpenRes || "tab_bg";
    
    //The "Force in Sidebar" feature was suggested and
    //developed by Jan Sch?nherr (janschh at users.sourceforge.net)
    if (useTargetForOpen == "sidebar"){
        // open the sidebar
        if (openWebPanel(item.Title,"about:blank")) { //openWebPanel lives in main.js
            // [[following code structure loosly based on
            // chrome://browser/content/browser.js -> openWebPanel() ]]
            cqr_sidebar = document.getElementById("sidebar");
            if( cqr_sidebar.contentDocument && cqr_sidebar.contentDocument.getElementById("web-panels-browser") ){
                // sidebar already open...
                if ( cqrEntryId ){
                cqrEntryId = "";
                cqr_sidebar.removeEventListener("load",asyncGetOpenTarget,true);
                }
                return cqr_sidebar.contentDocument.getElementById("web-panels-browser");
            } else {
                // sidebar still loading... take an extra round-trip
                if ( !cqrEntryId )
                cqr_sidebar.addEventListener("load",asyncGetOpenTarget, true);
                cqrEntryId = EntryId;
                return null;
            }
        } else {
            useTargetForOpen = cqrOpenRes;
        };
    }

    if (useTargetForOpen == "same_win") {
        return cqr_browser.selectedTab;
    } else if ((useTargetForOpen == "win_fg") || (useTargetForOpen == "win_bg") || (item.openwin)) {
        if (item.opentarget){
            //If plugin has "opentarget" param, then we should enumerate all windows
            //and possibly all tabs inside them looking for already opened target window
            var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].
                getService(Components.interfaces.nsIWindowMediator);
            var enumerator = windowManager.getEnumerator(null);
            while (enumerator.hasMoreElements()) {
                newBrowser = enumerator.getNext().getBrowser();
                newWin = newBrowser.contentWindow;
                //If user has more then one tab opened in window, 
                //our target tab may be not focused:
                var cntTabs = newBrowser.mTabContainer.childNodes.length;
                for (i=0;i<cntTabs;i++){
                    nextTab = newBrowser.mTabContainer.childNodes[i];
                    newTabBr = newBrowser.getBrowserForTab(nextTab);
                    if (newTabBr.contentWindow.name == item.opentarget){
                        if (cqrOpenRes == "win_bg") window.focus();
                        else newWin.focus();
                        return newTabBr.contentWindow; 
                    }
                }
            }
        //EOf "opentarget" processing
        }
        target = window.open("about:blank", item.opentarget, item.openwin);
        if (useTargetForOpen == "win_bg") window.focus();
        else target.focus();
        return target;
    } else if ((useTargetForOpen == "tab_fg") || (useTargetForOpen == "tab_bg")){
        if (item.opentarget){
            //enumerating all open tabs checking for "cqr_name" custom property defined by ConQuery
            //if there is an "opentarget" in plugin
            var cntTabs = cqr_browser.mTabContainer.childNodes.length;
            for (i=0;i<cntTabs;i++){
                myTab = cqr_browser.mTabContainer.childNodes[i];
                if (myTab.cqr_name == item.opentarget){
                    if (useTargetForOpen == "tab_fg") cqr_browser.selectedTab = myTab;
                    return myTab;
                }
            }
        }
        if (cqrPageURL == 'about:blank'){
            //just little feature: load query in the same tab if that tab is empty
            //XXX should we set "cqr_name" for "opentarget" here? IMO shouldn't
            //myTab.cqr_name = item.opentarget;
            myTab = cqr_browser.selectedTab;
            return myTab;
        } else {
            myTab = cqr_browser.addTab();
            myTab.cqr_name = item.opentarget;
            if (useTargetForOpen == "tab_fg") cqr_browser.selectedTab = myTab;
            return myTab;
        }
    }
}catch(err){cqerr(err, 'getOpenTarget sub')}
}

function asyncGetOpenTarget(event){
    var cqr_sidebar = document.getElementById("sidebar");
    if (cqrEntryId && cqr_sidebar.contentDocument && cqr_sidebar.contentDocument.getElementById('web-panels-browser')) {
        cqrOpenTarget = cqr_sidebar.contentDocument.getElementById("web-panels-browser");
        window.setTimeout('formIt("'+ cqrEntryId + '");', 70);
    }
    cqrEntryId = "";
    cqr_sidebar.removeEventListener("load", asyncGetOpenTarget, true);
}

function formIt(EntryId){
var entry = EntryHash._Item(EntryId);
    if (cqrOpenTarget.document){
        //this is an window obj
        doc = cqrOpenTarget.document;
        newBrowser = cqrGetBrowserForWindow(cqrOpenTarget);
        //show(newBrowser);
    } else if (cqrOpenTarget.contentDocument){
    	//this is already a browser object (used by sidebar-support)
        newBrowser = cqrOpenTarget;
        doc = newBrowser.contentDocument;
    } else {
        //this is a tab obj
        newBrowser = cqr_browser.getBrowserForTab(cqrOpenTarget);
        doc = newBrowser.contentDocument;
    }

    //show("charset>>>"+cqrCurPageCharset);
    
    //if (entry.referrer){
        //I'm too dumb to figure out how to spoof referrer under Moz other then with window.open() :(
        //The problem is that I have the window already opened while processing query. So to spoof a
        //referrer I should somehow hack the window.location object.
        //Well, later, maybe.
    //}

    if ((cqrAction) && (!entry.Inputs)){
        //treat query plugins without any <input> tag as simple link
        newBrowser.loadURI(cqrAction);
        resetenv();
        return;
    }

    
    try{
      var sbmt = null;
      var frm = doc.createElementNS("http://www.w3.org/1999/xhtml", "form");
      frm.setAttribute("name", "cqrform");
      if (entry.Action){
        frm.setAttribute("action", cqrAction);
      } else {
        frm.setAttribute("action", entry.Action);
      }
      frm.setAttribute("method", entry.Method);
      frm.setAttribute("style", "display: none;");
      frm.setAttribute("accept-charset", entry.qcharset);
      if (cqrMailFlag) frm.setAttribute("target", "_blank");
      for (each in QueryHash){
          // we should be aware of <input name="submit"> :))
          if (each == "submit"){
              sbmt = doc.createElementNS("http://www.w3.org/1999/xhtml", "input");
              sbmt.setAttribute("type", "submit");
              sbmt.setAttribute("name", each);
              sbmt.setAttribute("value", unescape(QueryHash[each]));
              frm.appendChild(sbmt);
              continue;
          }
          var inp = doc.createElementNS("http://www.w3.org/1999/xhtml", "input");
          inp.setAttribute("type", "hidden");
          inp.setAttribute("name", each);
          inp.setAttribute("value", unescape(QueryHash[each]));
          frm.appendChild(inp);
      }
      doc.documentElement.appendChild(frm);
      if (sbmt!=null){
          frm.submit.click();
      } else {
          frm.submit();
      }
    } catch(er){cqerr(er, "formIt sub")}
    resetenv();    
}

function PrepareAction(EntryObj){
try{
  cqrAction = SubstVars(EntryObj.Action, EntryObj);
  for (i in EntryObj.Inputs){
    QueryHash[EntryObj.Inputs[i].def.name] = SubstVars(EntryObj.Inputs[i].def.value, EntryObj);
  }
  if (cqrShowAlternatives) window.openDialog("chrome://conquery/content/list.xul","_blank", "centerscreen,chrome,modal,resizable=yes", EntryObj);
}catch(er){cqerr(er, "PrepareAction sub")}
}

function SubstVars(str, EntryObj){
    var retstr = "";
    cqrvars = cqrSIRe.exec(str);
    lastind = 0;
    if (cqrvars){
      while (cqrvars){
        tmpstr = str.substring(lastind, cqrSIRe.lastIndex);
        switch("[:"+cqrvars[1]+"]"){
          case "[:selection]":
            if (cqrPageSelection == "") cqrShowAlternatives=true;
            retstr += tmpstr.replace("[:selection]", cqrPageSelection);
            break;
          case "[:url]":
            retstr += tmpstr.replace("[:url]", cqrPageURL);
            break;
          case "[:linkurl]":
            retstr += tmpstr.replace("[:linkurl]", cqrLinkURL);
            break;
          case "[:imgurl]":
            retstr += tmpstr.replace("[:imgurl]", cqrImgURL);
            break;
          case "[:imgname]":
            retstr += tmpstr.replace("[:imgname]", cqrImgName);
            break;
          case "[:host]":
            retstr += tmpstr.replace("[:host]", cqrPageHost);
            break;
          case "[:title]":
            retstr += tmpstr.replace("[:title]", cqrPageTitle);
            break;
          case "[:source]":
            retstr += tmpstr.replace("[:source]", cqrPageSource);
            break;
          case "[:text]":
            retstr += tmpstr.replace("[:text]", "");
            break;
          case "[:cliptext]":
            retstr += tmpstr.replace("[:cliptext]", cqrClipboardText);
            break;
          case "[:matched]":
            var matchnum = Number(cqrvars[3]);
            if (isNaN(matchnum)) matchnum = 0;
            if (EntryObj.lastmatch[matchnum]){
              retstr += tmpstr.replace(cqrvars[0], EntryObj.lastmatch[matchnum]);
            }else{
              retstr += tmpstr.replace(cqrvars[0], "");
            }
            break;
          case "[:prompt]":
            cqrShowAlternatives=true;
            retstr += tmpstr.replace("[:prompt]", "");
            break;
          //if variable is not recognized
          default:
            retstr += tmpstr;
        }
      lastind = cqrSIRe.lastIndex;
      cqrvars = cqrSIRe.exec(str);
      }
      retstr += str.substring(lastind);
    } else {retstr = str}
    return retstr;
}

function OpenCfgDialog(){
    window.openDialog("chrome://conquery/content/conquery-pref.xul", cqrMess.GetStringFromName('cqr.cfg.wTitle'), "centerscreen,chrome,modal,resizable=yes");
  if (cqrConfigLastWillId){
    ProcessEntry(cqrConfigLastWillCtrl, cqrConfigLastWillId);
    cqrConfigLastWillId = "";
  }
}

function evalContext(entryObj){
    if (entryObj.showif == "") return false;
    
    var res = new Object;
    trg = SubstVars(entryObj.sitarget, entryObj);
    cqrShowAlternatives=false;
    res = entryObj.si_compiled.exec(trg);
    entryObj.si_compiled.lastIndex=0;
    if (res){
        EntryHash.Items[entryObj.eId].lastmatch = res;
        //show("Matched values for " + EntryHash.Items[entry].Title + ":");
        //for (each in res) show(each + ": " + res[each]);
        return true;
    } else {
        EntryHash.Items[entryObj.eId].lastmatch = [];
        EntryHash.Items[entryObj.eId].lastmatch[0] = trg;
        return false;
    }
}

function getPageParams(event){
    var focusedWindow = document.commandDispatcher.focusedWindow;
    try{
        cqrPageSelection = "";
        //Thanks to Yuriy for textbox & textarea selection extraction
        var node = event.explicitOriginalTarget;
        if ((node) && 
            ((node.nodeName.toUpperCase() == "TEXTAREA") ||
            (node.nodeName.toUpperCase() == "INPUT" && node.type == "text"))) {
            cqrPageSelection = node.value.substring(node.selectionStart, node.selectionEnd);
        }else{
            //new way to get selection using Native Wrappers. Can be incompatible with older versions of Firefox
            var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
            cqrPageSelection = winWrapper.getSelection();
        }
    }catch(er){cqrPageSelection=""}

    try{
        cqrPageURL = decodeURIComponent(focusedWindow.location.href);
    }catch(er){cqrPageURL=""}
    
    try{
          cqrPageHost = focusedWindow.location.host;
    }catch(er){cqrPageHost=""}

    try{
          cqrPageTitle = focusedWindow.document.title;
    }catch(er){cqrPageTitle=""}

    try{
        cqrPageSource = focusedWindow.document.documentElement.innerHTML;
    }catch(er){cqrPageSource=""}

    cqrLinkURL = cqrFindParentNode(event.originalTarget, "a");
    if (cqrLinkURL) cqrLinkURL = decodeURIComponent(cqrLinkURL);
    cqrAreaObj = cqrFindParentNode(event.originalTarget, "area");
    if (cqrAreaObj) cqrLinkURL = cqrAreaObj.href;
        cqrImgObj = cqrFindParentNode(event.originalTarget, "img");
    if (cqrImgObj){
        cqrImgURL = decodeURIComponent(cqrAbsURI(cqrImgObj.baseURI, cqrImgObj.src));
        cqrImgName = getFNameFromURI(cqrImgURL);
    } else {
        cqrImgURL = "";
        cqrImgName = "";
    }
    if (!cqrLinkURL) cqrLinkURL = "";
    
    cqrClipboardText = cqrGetClipboardText() || "";
    cqrCurPageCharset = cqr_browser.documentCharsetInfo;
    //var atomService = Components.classes['@mozilla.org/atom-service;1'].getService(Components.interfaces.nsIAtomService);
    
    //show("this doc sharset >>>" + focusedWindow.document.characterSet);
    
    //show("pchar>>>"+atomService.getAtom(gBrowser.documentCharsetInfo.parentCharset).toString());
    //show("fchar>>>"+atomService.getAtom(gBrowser.documentCharsetInfo.forcedCharset).toString());
    //show("bchar>>>" + cqrNavigatorDefaultCharset);
}

function cqrFindParentNode(node, parentNode)
{
  //borrowed from:
  //toolkit.jar:content\help\help.js
  if (node && node.nodeType == Node.TEXT_NODE) {
    node = node.parentNode;
  }
  while (node) {
    if (node.nodeType == Node.DOCUMENT_NODE) {
      return null;
    }
    var nodeName = node.localName;
    if (!nodeName)
      return null;
    nodeName = nodeName.toLowerCase();
    if (nodeName == "body" || nodeName == "html") {
      return null;
    }
    if (nodeName == parentNode)
      return node;
    node = node.parentNode;
  }
  return null;
}

function resetenv(){
    QueryHash = new Object();
    cqrOpenTarget = null;
    cqrPageSelection = "";
    cqrPageURL = "";
    cqrPageHost = "";
    cqrLinkURL = "";
    cqrImgName = "";
    cqrImgURL = "";
    cqrPageTitle = "";
    cqrPageSource = "";
    cqrAction = "";
    cqrConfigLastWillId = "";
    cqrConfigLastWillCtrl = false;
    cqrShowAlternatives = false;
    cqrcancel = false;
    cqrTabRef = "";
    cqrWndRef = "";
    cqrClipboardText = "";
    cqrCurPageCharset = "";
}
